class Controller {

    constructor() {
        this.evalInput();
        this.info = document.getElementById("info");
        this.elapsed = document.getElementById("elapsed");
    }
    //read string from input field
    getKeyInput() {
        let inputs = document.autoForm.numberM.value.split("x");
        return inputs;
    }

    //connect model, view
    evalInput() {
        //set number of rows, columns (m, n)
        document.getElementById("generateBtn").addEventListener("click", () => {
            this.generate();
        });
    }

    generate() {
        this.elapsed.innerHTML = this.info.innerHTML = "";
        let swap = document.getElementById("commCheck").checked;
        let mn = this.getKeyInput();
        let worker = new Worker('worker/workerCalc.js');
        let fWriter = new FileWriter();
        let res = "";
        let allMode = document.autoForm.elements.mode;


        try {
            if (mn.length !== 2 || isNaN(mn[0]) || mn[0] === "" || isNaN(mn[1]) || mn[1] === "") {
                throw "input is not valid";
            } else {
                worker.postMessage([allMode.value, swap, mn[1], mn[0]]);
                worker.onmessage = (event) => {
                    this.elapsed.innerHTML = `elapsed time: ${event.data[1]}`;
                    fWriter.setContent(event.data[0]);
                    fWriter.createFile();
                }
            }
        } catch (error) {
            this.info.innerHTML = error;
        }
    }
}